<?php
/**
 * BrainyModule 2019
 */
if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}
// Require any libraries needed for the module to function.
require_once __DIR__ . '/lib/api.php';



if (!defined("DS"))
    define('DS', DIRECTORY_SEPARATOR);
if (function_exists('mysql_safequery') == false)
{
    function mysql_safequery($query, $params = false)
    {
        if ($params)
        {
            foreach ($params as &$v)
            {
                $v = mysql_real_escape_string($v);
            }
            $sql_query = vsprintf(str_replace("?", "'%s'", $query), $params);
            $sql_query = mysql_query($sql_query);
        }
        else
        {
            $sql_query = mysql_query($query);
        }
        return ($sql_query);
    }
}

if (isset($_SESSION['Language']))
{
    $language = strtolower($_SESSION['Language']);
}
else
{
    $q        = mysql_safequery("SELECT language FROM tbladmins WHERE id = ?", array(intval($_SESSION['adminid'])));
    $row      = mysql_fetch_assoc($q);
    $language = $_SESSION['Language'] = empty($row['language']) ? strtolower($smarty->_tpl_vars['language']) : strtolower($row['language']);
}

$maindir         = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), 'modules' . DS . 'servers'));
$langfilename    = $maindir . 'modules' . DS . 'servers' . DS . 'brainy' . DS . 'lang' . DS . $language . '.php';
$deflangfilename = $maindir . 'modules' . DS . 'servers' . DS . 'brainy' . DS . 'lang' . DS . 'english.php';

if (file_exists($langfilename)) {
    require_once $langfilename;
} else {
    require_once $deflangfilename;
}

/*echo 	'<style type="text/css">
                </style>
                <script type="text/javascript">
                    $(document).ready(function()
                    {
                        if($("select[name*=\"servertype\"]").val()=="brainy"){
                            $("<div>Created by BrainyCP. For more information visit our <a target=\"_blank\" href=\"https://docs.brainycp.com/index.php\">Wiki</a>.</div>").insertBefore($("#tab3").find("table").eq(1));
                        }
                    });
        </script>';*/



//
// Also, perform any initialization required by the service's library.
/**
 * Define module related meta data.
 *
 * Values returned here are used to determine module related abilities and
 * settings.
 *
 * @see https://developers.whmcs.com/provisioning-modules/meta-data-params/
 *
 * @return array
 */
function brainy_MetaData()
{
    return array(
        'DisplayName' => 'Brainy',
        'APIVersion' => '1.1', // Use API Version 1.1
        'RequiresServer' => true, // Set true if module requires a server to work
        'DefaultNonSSLPort' => '8002', // Default Non-SSL Connection Port
        'DefaultSSLPort' => '8000', // Default SSL Connection Port
        'ServiceSingleSignOnLabel' => 'Login to Brainy as User',
        'AdminSingleSignOnLabel' => 'Login to Brainy as Admin',
        'language' => 'english',
    );
}
/**
 * Define product configuration options.
 *
 * The values you return here define the configuration options that are
 * presented to a user when configuring a product for use with the module. These
 * values are then made available in all module function calls with the key name
 * configoptionX - with X being the index number of the field from 1 to 24.
 *
 * You can specify up to 24 parameters, with field types:
 * * text
 * * password
 * * yesno
 * * dropdown
 * * radio
 * * textarea
 *
 * Examples of each and their possible configuration parameters are provided in
 * this sample function.
 *
 * @see https://developers.whmcs.com/provisioning-modules/config-options/
 *
 * @return array
 */

function brainy_ConfigOptions()
{
    global $_BRAINY_LANG;
    return array(
        // a text field type allows for single line text input
        $_BRAINY_LANG["WHM_PACKAGE_NAME"] => array(
            'Type' => 'text',
            'Size' => '25',
            'Default' => '',
            'Description' => '',
        ),
        $_BRAINY_LANG["MAX_FTP"] => array(
            'Type' => 'text',
            'Size' => '10',
            'Default' => '0',
            'Description' => '',
        ),
        $_BRAINY_LANG["SPACE_QUOTA"] => array(
            'Type' => 'text',
            'Size' => '10',
            'Default' => '0',
            'Description' => 'MB',
        ),
        $_BRAINY_LANG["MAX_EMAIL"] => array(
            'Type' => 'text',
            'Size' => '10',
            'Default' => '0',
            'Description' => '',
        ),
        $_BRAINY_LANG["BANDWIDTH_LIMIT"] => array(
            'Type' => 'text',
            'Size' => '10',
            'Default' => '0',
            'Description' => 'MB',
        ),
        $_BRAINY_LANG["MAX_DATABASE"] => array(
            'Type' => 'text',
            'Size' => '10',
            'Default' => '0',
            'Description' => '',
        ),
        $_BRAINY_LANG["SHELL_ACCESS"] => array(
            'Type' => 'yesno',
            'Size' => '10',
            'Default' => '',
            'Description' => $_BRAINY_LANG["TICK_ACCESS"],
        ),
        $_BRAINY_LANG["MAX_DOMAIN"] => array(
            'Type' => 'text',
            'Size' => '10',
            'Default' => '0',
            'Description' => '',
        ),
        $_BRAINY_LANG["SETGROUP"] => array(
            'Type' => 'text',
            'Size' => '25',
            'Default' => '',
            'Description' => $_BRAINY_LANG["SETGROUP_HELP"],
        ),
        $_BRAINY_LANG["MAX_DNS"] => array(
            'Type' => 'text',
            'Size' => '10',
            'Default' => '0',
            'Description' => '',
        ),
        $_BRAINY_LANG["MAX_DATABASE"] => array(
            'Type' => 'text',
            'Size' => '10',
            'Default' => '0',
            'Description' => '',
        ),

        // a password field type allows for masked text input
        /*'Password Field' => array(
            'Type' => 'password',
            'Size' => '25',
            'Default' => '',
            'Description' => 'Enter secret value here',
        ),
        // the yesno field type displays a single checkbox option
        'Checkbox Field' => array(
            'Type' => 'yesno',
            'Description' => 'Tick to enable',
        ),
        // the dropdown field type renders a select menu of options
        'Dropdown Field' => array(
            'Type' => 'dropdown',
            'Options' => array(
                'option1' => 'Display Value 1',
                'option2' => 'Second Option',
                'option3' => 'Another Option',
            ),
            'Description' => 'Choose one',
        ),
        // the radio field type displays a series of radio button options
        'Radio Field' => array(
            'Type' => 'radio',
            'Options' => 'First Option,Second Option,Third Option',
            'Description' => 'Choose your option!',
        ),
        // the textarea field type allows for multi-line text input
        'Textarea Field' => array(
            'Type' => 'textarea',
            'Rows' => '3',
            'Cols' => '60',
            'Description' => 'Freeform multi-line text input field',
        ),*/
    );
}
/**
 * Provision a new instance of a product/service.
 *
 * Attempt to provision a new instance of a given product/service. This is
 * called any time provisioning is requested inside of WHMCS. Depending upon the
 * configuration, this can be any of:
 * * When a new order is placed
 * * When an invoice for a new order is paid
 * * Upon manual request by an admin user
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return string "success" or an error message
 */
function brainy_CreateAccount(array $params)
{
    try {

        if($params["serversecure"]=="on"){
            $secure=1;
        }else{
            $secure=0;
        }

        $params_api=array(
            "lg"=>$params["username"],
            "ps"=>$params["password"],
            "plan"=>$params["configoption1"],
            "group"=>$params["configoption9"],
            "emailboxes"=>$params["configoption4"],
            "bandwidth"=>$params["configoption5"],
            "sites"=>$params["configoption8"],
            "dns_zones"=>$params["configoption10"],
            "disk"=>$params["configoption3"],
            "ftp_accounts"=>$params["configoption2"],
            "shell_access"=>$params["configoption7"],
            "databases"=>$params["configoption6"],
            "domain"=>$params["domain"],
            "ignore_error"=>1,
            "secure"=>$secure,
        );


        $params_api_dom=array(
            "user_edit"=>$params["username"],
            "domains"=>$params["domain"],
            "dir"=>$params["domain"],
            "bridge"=>"defaultbr",
            "php_version"=>"defaultphp",
            "ignore_error"=>1,
            "secure"=>$secure,
        );
        $res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","adduseracc", $params_api, $params["serverhostname"],$params["serveraccesshash"]);//backup config autoins list of install app
        if($res["code"]===0 || $res['err']===0){
            $res=api_send($params["serverusername"], $params["serverpassword"],"server_control","add_domain", $params_api_dom, $params["serverhostname"],$params["serveraccesshash"]);//backup config autoins list of install app
            $success = "success";
        }else{
            if(is_array($res)) {
                $success = $res["mess"];
            }else {
                $success = $res;
            }
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'brainymodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return $success;
}
/**
 * Suspend an instance of a product/service.
 *
 * Called when a suspension is requested. This is invoked automatically by WHMCS
 * when a product becomes overdue on payment or can be called manually by admin
 * user.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return string "success" or an error message
 */
function brainy_SuspendAccount(array $params)
{
    global $_BRAINY_LANG;
    try {
        if($params["serversecure"]=="on"){
            $secure=1;
        }else{
            $secure=0;
        }
        $params_api=array(
            "logintosusp"=>$params["username"],
            "action"=>"suspend_full",
            "suspendreason"=>$params["suspendreason"],
            "ignore_error"=>1,
            "secure"=>$secure,
        );
        $res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","suspendacc", $params_api, $params["serverhostname"],$params["serveraccesshash"]);//backup config autoins list of install app
        if($res["code"]===0 || $res['err']===0 || $res['error']===0){
            $success = "success";
        }else{
            if(isset($res["mess"])) {
                $success = $res["mess"];
            }else{
                $success = $_BRAINY_LANG["HOSTACC_USER_NOT_EXIST"];
            }
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return $success;
}
/**
 * Un-suspend instance of a product/service.
 *
 * Called when an un-suspension is requested. This is invoked
 * automatically upon payment of an overdue invoice for a product, or
 * can be called manually by admin user.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return string "success" or an error message
 */
function brainy_UnsuspendAccount(array $params)
{
    global $_BRAINY_LANG;
    try {
        if($params["serversecure"]=="on"){
            $secure=1;
        }else{
            $secure=0;
        }
        $params_api=array(
            "logintosusp"=>$params["username"],
            "action"=>"unsuspend_full",
            "ignore_error"=>1,
            "secure"=>$secure,
        );
        $res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","unsuspendacc", $params_api, $params["serverhostname"],$params["serveraccesshash"]);//backup config autoins list of install app
        if($res["code"]===0 || $res['err']===0 || $res['error']===0){
            $success = "success";
        }else{
            if(isset($res["mess"])) {
                $success = $res["mess"];
            }else{
                $success = $_BRAINY_LANG["HOSTACC_USER_NOT_EXIST"];
            }
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return $success;
}
/**
 * Terminate instance of a product/service.
 *
 * Called when a termination is requested. This can be invoked automatically for
 * overdue products if enabled, or requested manually by an admin user.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return string "success" or an error message
 */
function brainy_TerminateAccount(array $params)
{
    global $_BRAINY_LANG;
    try {
        $params_api=array(
            "logintoterm"=>$params["username"],
            "ignore_error"=>1,
            "secure"=>$params["serversecure"]=="on"?1:0,
        );
        $res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","terminateacc", $params_api, $params["serverhostname"],$params["serveraccesshash"]);//backup config autoins list of install app
        //102 code -  уже удален
        if($res["code"]===0 || $res['err']===0 || $res['err']===102 || $res['error']===0){
            $success = "success";
        }else{
            if(isset($res["mess"])) {
                $success = $res["mess"];
            }else{
                $success = $_BRAINY_LANG["HOSTACC_USER_NOT_EXIST"];
            }
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return $success;
}
/**
 * Change the password for an instance of a product/service.
 *
 * Called when a password change is requested. This can occur either due to a
 * client requesting it via the client area or an admin requesting it from the
 * admin side.
 *
 * This option is only available to client end users when the product is in an
 * active status.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return string "success" or an error message
 */
function brainy_ChangePassword(array $params)
{
    global $_BRAINY_LANG;
    try {
        $params_api=array(
            "managelogin"=>$params["username"],
            "newpassword"=>$params["password"],
            "ignore_error"=>1,
            "secure"=>$params["serversecure"]=="on"?1:0,
        );
        $res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","changepass", $params_api, $params["serverhostname"],$params["serveraccesshash"]);//backup config autoins list of install app
        if($res["code"]===0 || $res['err']===0 || $res['error']===0){
            $success = "success";
        }else{
            if(isset($res["mess"])) {
                $success = $res["mess"];
            }else{
                $success = $_BRAINY_LANG["HOSTACC_USER_NOT_EXIST"];
            }
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return $success;
}
/**
 * Upgrade or downgrade an instance of a product/service.
 *
 * Called to apply any change in product assignment or parameters. It
 * is called to provision upgrade or downgrade orders, as well as being
 * able to be invoked manually by an admin user.
 *
 * This same function is called for upgrades and downgrades of both
 * products and configurable options.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return string "success" or an error message
 */
function brainy_ChangePackage(array $params)
{
    global $_BRAINY_LANG;
    try {
        $params_api=array(
            "managelogin"=>$params["username"],
            "newplan"=>$params["configoption1"],
            "ignore_error"=>1,
            "secure"=>$params["serversecure"]=="on"?1:0,
        );
        $res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","changeplan", $params_api, $params["serverhostname"],$params["serveraccesshash"]);//backup config autoins list of install app
        if($res["code"]===0 || $res['err']===0 || $res['error']===0){
            $success = "success";
        }else{
            if(isset($res["mess"])) {
                $success = $res["mess"];
            }else{
                $success = $_BRAINY_LANG["HOSTACC_USER_NOT_EXIST"];
            }
        }

    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'brainymodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return 'success';
}
/**
 * Test connection with the given server parameters.
 *
 * Allows an admin user to verify that an API connection can be
 * successfully made with the given configuration parameters for a
 * server.
 *
 * When defined in a module, a Test Connection button will appear
 * alongside the Server Type dropdown when adding or editing an
 * existing server.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return array
 */
function brainy_TestConnection(array $params)
{

    global $_BRAINY_LANG;

    if($params["serversecure"]=="on"){
        $secure=1;
    }else{
        $secure=0;
    }
    try {
        // Call the service's connection test function.
        //$res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","adduseracc", array("checkconnect"=>1,"secure"=>$secure), $params["serverip"],$params["serveraccesshash"]);
        $res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","adduseracc", array("checkconnect"=>1,"secure"=>$secure), $params["serverhostname"],$params["serveraccesshash"]);
        if(!is_array($res)){
            $success = false;
            if(stripos($res,"Connection Error")!==false){
                $errorMsg = $res;
            }
        }else {
            if ($res["code"] == 0) {
                if (!is_array(($res)) && stripos($res, "Failed to connect") !== false) {
                    $success = false;
                    $errorMsg = $res;
                } else {
                    $success = true;
                }
            } else {
                $success = false;
                if (isset($res['message'])) {
                    $errorMsg = $res['message'];
                } else {
                    $errorMsg = $_BRAINY_LANG["ERROR_CONNECT"];
                }
            }
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'brainy',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        $success = false;
        $errorMsg = $e->getMessage();
    }
    return array(
        'success' => $success,
        'error' => $errorMsg,
    );
}
/**
 * Additional actions an admin user can invoke.
 *
 * Define additional actions that an admin user can perform for an
 * instance of a product/service.
 *
 * @see provisioningmodule_buttonOneFunction()
 *
 * @return array
 */
function brainy_AdminCustomButtonArray()
{
    global $_BRAINY_LANG;
    return array(
        $_BRAINY_LANG["SUSP_SITES"] => 'buttonSuspsites',
        $_BRAINY_LANG["UNSUSP_SITES"] => 'buttonUnsuspsites',
    );
}

function brainy_buttonSuspsites(array $params)
{
    try {
        $params_api=array(
            "logintosusp"=>$params["username"],
            "action"=>"suspend_sites",
            "suspendreason"=>$params["suspendreason"],
            "ignore_error"=>1,
            "secure"=>$params["serversecure"]=="on"?1:0,
        );
        $res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","suspendacc", $params_api, $params["serverhostname"],$params["serveraccesshash"]);//backup config autoins list of install app
        if($res["code"]===0 || $res['err']===0 || $res['error']===0){
            $success = "success";
        }else{
            if(isset($res["mess"])) {
                $success = $res["mess"];
            }else{
                $success = $_BRAINY_LANG["HOSTACC_USER_NOT_EXIST"];
            }
        }

    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return 'success';
}

function brainy_buttonUnsuspsites(array $params)
{
    try {
        $params_api=array(
            "logintosusp"=>$params["username"],
            "action"=>"unsuspend_sites",
            "ignore_error"=>1,
            "secure"=>$params["serversecure"]=="on"?1:0,
        );
        $res=api_send($params["serverusername"], $params["serverpassword"],"hostacc","unsuspendacc", $params_api, $params["serverhostname"],$params["serveraccesshash"]);//backup config autoins list of install app
        if($res["code"]===0 || $res['err']===0 || $res['error']===0){
            $success = "success";
        }else{
            if(isset($res["mess"])) {
                $success = $res["mess"];
            }else{
                $success = $_BRAINY_LANG["HOSTACC_USER_NOT_EXIST"];
            }
        }

    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return 'success';
}
/**
 * Additional actions a client user can invoke.
 *
 * Define additional actions a client user can perform for an instance of a
 * product/service.
 *
 * Any actions you define here will be automatically displayed in the available
 * list of actions within the client area.
 *
 * @return array
 */
function provisioningmodule_ClientAreaCustomButtonArray()
{
    return array(
        "Action 1 Display Value" => "actionOneFunction",
        "Action 2 Display Value" => "actionTwoFunction",
    );
}
/**
 * Custom function for performing an additional action.
 *
 * You can define an unlimited number of custom functions in this way.
 *
 * Similar to all other module call functions, they should either return
 * 'success' or an error message to be displayed.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 * @see provisioningmodule_AdminCustomButtonArray()
 *
 * @return string "success" or an error message
 */
function provisioningmodule_buttonOneFunction(array $params)
{
    try {
        // Call the service's function, using the values provided by WHMCS in
        // `$params`.
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return 'success';
}
/**
 * Custom function for performing an additional action.
 *
 * You can define an unlimited number of custom functions in this way.
 *
 * Similar to all other module call functions, they should either return
 * 'success' or an error message to be displayed.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 * @see provisioningmodule_ClientAreaCustomButtonArray()
 *
 * @return string "success" or an error message
 */
function provisioningmodule_actionOneFunction(array $params)
{
    try {
        // Call the service's function, using the values provided by WHMCS in
        // `$params`.
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return 'success';
}
/**
 * Admin services tab additional fields.
 *
 * Define additional rows and fields to be displayed in the admin area service
 * information and management page within the clients profile.
 *
 * Supports an unlimited number of additional field labels and content of any
 * type to output.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 * @see provisioningmodule_AdminServicesTabFieldsSave()
 *
 * @return array
 */
function provisioningmodule_AdminServicesTabFields(array $params)
{
    try {
        // Call the service's function, using the values provided by WHMCS in
        // `$params`.
        $response = array();
        // Return an array based on the function's response.
        return array(
            'Number of Apples' => (int) $response['numApples'],
            'Number of Oranges' => (int) $response['numOranges'],
            'Last Access Date' => date("Y-m-d H:i:s", $response['lastLoginTimestamp']),
            'Something Editable' => '<input type="hidden" name="provisioningmodule_original_uniquefieldname" '
                . 'value="' . htmlspecialchars($response['textvalue']) . '" />'
                . '<input type="text" name="provisioningmodule_uniquefieldname"'
                . 'value="' . htmlspecialchars($response['textvalue']) . '" />',
        );
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        // In an error condition, simply return no additional fields to display.
    }
    return array();
}
/**
 * Execute actions upon save of an instance of a product/service.
 *
 * Use to perform any required actions upon the submission of the admin area
 * product management form.
 *
 * It can also be used in conjunction with the AdminServicesTabFields function
 * to handle values submitted in any custom fields which is demonstrated here.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 * @see provisioningmodule_AdminServicesTabFields()
 */
function provisioningmodule_AdminServicesTabFieldsSave(array $params)
{
    // Fetch form submission variables.
    $originalFieldValue = isset($_REQUEST['provisioningmodule_original_uniquefieldname'])
        ? $_REQUEST['provisioningmodule_original_uniquefieldname']
        : '';
    $newFieldValue = isset($_REQUEST['provisioningmodule_uniquefieldname'])
        ? $_REQUEST['provisioningmodule_uniquefieldname']
        : '';
    // Look for a change in value to avoid making unnecessary service calls.
    if ($originalFieldValue != $newFieldValue) {
        try {
            // Call the service's function, using the values provided by WHMCS
            // in `$params`.
        } catch (Exception $e) {
            // Record the error in WHMCS's module log.
            logModuleCall(
                'provisioningmodule',
                __FUNCTION__,
                $params,
                $e->getMessage(),
                $e->getTraceAsString()
            );
            // Otherwise, error conditions are not supported in this operation.
        }
    }
}
/**
 * Perform single sign-on for a given instance of a product/service.
 *
 * Called when single sign-on is requested for an instance of a product/service.
 *
 * When successful, returns a URL to which the user should be redirected.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return array
 */
function brainy_ServiceSingleSignOn(array $params)
{
    try {
        // Call the service's single sign-on token retrieval function, using the
        // values provided by WHMCS in `$params`.
        $username=$params["username"];
        $password=$params["password"];
        $server_pref=$params["serverhttpprefix"];
        $server_port=$params["serverport"];
        $server_ip=$params["serverip"];
        $serverhostname=$params["serverhostname"];
        $response = $server_pref."://".$serverhostname.":".$server_port."/auth.php?user=".$username."&pass=".urlencode($password);
        return array(
            'success' => true,
            'redirectTo' => $response,
        );
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return array(
            'success' => false,
            'errorMsg' => $e->getMessage(),
        );
    }
}
/**
 * Perform single sign-on for a server.
 *
 * Called when single sign-on is requested for a server assigned to the module.
 *
 * This differs from ServiceSingleSignOn in that it relates to a server
 * instance within the admin area, as opposed to a single client instance of a
 * product/service.
 *
 * When successful, returns a URL to which the user should be redirected to.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return array
 */
function brainy_AdminSingleSignOn(array $params)
{
    try {
        // Call the service's single sign-on admin token retrieval function,
        // using the values provided by WHMCS in `$params`.
        $username=$params["serverusername"];
        $password=$params["serverpassword"];
        $server_pref=$params["serverhttpprefix"];
        $server_port=$params["serverport"];
        $server_ip=$params["serverip"];
        $serverhostname=$params["serverhostname"];
        $response = $server_pref."://".$serverhostname.":".$server_port."/auth.php?user=".$username."&pass=".urlencode($password);
        return array(
            'success' => true,
            'redirectTo' => $response,
        );
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return array(
            'success' => false,
            'errorMsg' => $e->getMessage(),
        );
    }
}
/**
 * Client area output logic handling.
 *
 * This function is used to define module specific client area output. It should
 * return an array consisting of a template file and optional additional
 * template variables to make available to that template.
 *
 * The template file you return can be one of two types:
 *
 * * tabOverviewModuleOutputTemplate - The output of the template provided here
 *   will be displayed as part of the default product/service client area
 *   product overview page.
 *
 * * tabOverviewReplacementTemplate - Alternatively using this option allows you
 *   to entirely take control of the product/service overview page within the
 *   client area.
 *
 * Whichever option you choose, extra template variables are defined in the same
 * way. This demonstrates the use of the full replacement.
 *
 * Please Note: Using tabOverviewReplacementTemplate means you should display
 * the standard information such as pricing and billing details in your custom
 * template or they will not be visible to the end user.
 *
 * @param array $params common module parameters
 *
 * @see https://developers.whmcs.com/provisioning-modules/module-parameters/
 *
 * @return array
 */
function brainy_ClientArea(array $params)
{

    $username = $params["username"];
    $password = $params["password"];
    $server_pref = $params["serverhttpprefix"];
    $server_port = $params["serverport"];
    $server_ip = $params["serverip"];


    /*$code = '<form action="' . $server_pref . '://' . $server_ip . ':' . $server_port . '/auth.php" method="get" target="_blank">
<input type="hidden" name="user" value="' . $username . '" />
<input type="hidden" name="pass" value="' . $password . '" />
<input type="submit" value="Login to BrainyCP" />
</form>';

    return $code;*/
    $requestedAction = isset($_REQUEST['customAction']) ? $_REQUEST['customAction'] : '';
    if ($requestedAction == 'manage') {
        $serviceAction = 'get_usage';
        $templateFile = 'templates/manage.tpl';
    } else {
        $serviceAction = 'get_stats';
        $templateFile = 'templates/overview.tpl';
    }
    try {
        // Call the service's function based on the request action, using the
        // values provided by WHMCS in `$params`.
        $response = array();
        $extraVariable1 = 'abc';
        $extraVariable2 = '123';
        return array(
            'tabOverviewReplacementTemplate' => $templateFile,
            'templateVariables' => array(
                'extraVariable1' => $extraVariable1,
                'extraVariable2' => $extraVariable2,
            ),
        );
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        // In an error condition, display an error page.
        return array(
            'tabOverviewReplacementTemplate' => 'error.tpl',
            'templateVariables' => array(
                'usefulErrorHelper' => $e->getMessage(),
            ),
        );
    }

}